/*
 * plctimingthread.h
 *
 *	08.03.07 - SF: heartbeat
 */ 

#ifndef plctimingthread_H
#define plctimingthread_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <signal.h>
#include <netdb.h>    
#include <PLCaccess.h>

#define TIMEADJUST_DEF_H 3
#define TIMEADJUST_DEF_M 6

class plctimingthread : public omni_thread, public Tango::LogAdapter
{	
	private:
		PLCaccess_ns::PLCaccess *t_PLCaccess;		
				
	public:
		plctimingthread(PLCaccess_ns::PLCaccess *s):Tango::LogAdapter(s){ t_PLCaccess = s;};
		~plctimingthread() {};
		void *StartUndetached(){
			start_undetached();
		}
		//void *run_undetached(void *);
		void run(void *);
		void log_states(PLCaccess_ns::db_51);		
		void log_states_new(PLCaccess_ns::db_51);
		void log_people(PLCaccess_ns::db_50);		
		void log_topup(PLCaccess_ns::topup_dblog);		
		
					
	protected:
		PLCaccess_ns::tstamp_s local_t;
		PLCaccess_ns::db_51 m_to_log;
		PLCaccess_ns::db_50 p_to_log;
		PLCaccess_ns::topup_dblog t_to_log;
				
};	



#endif

